#ifndef CHIP_MMAP_H
#define CHIP_MMAP_H

#include "chip_devtype_mem.h"

/* CODE MEMORY */
#define CHIP_MEMRGN_ADDR_FLASH                0x08000000UL
#define CHIP_MEMRGN_ADDR_ESIG                 0x1FFFF7E0UL
#define CHIP_MEMRGN_ADDR_OPTION_BYTES         0x1FFFF800UL
#define CHIP_MEMRGN_ADDR_VENDOR               0x1FFFF700UL
#define CHIP_MEMRGN_ADDR_SYSMEM               0x1FFFF000UL


/* RAM */
#define CHIP_MEMRGN_ADDR_SRAM                 0x20000000UL

/* Peripherals */
#define CHIP_MEMRGN_ADDR_APB1                 0x40000000UL
#define CHIP_MEMRGN_ADDR_APB2                 0x40010000UL
#define CHIP_MEMRGN_ADDR_AHB                  0x40020000UL
#define CHIP_MEMRGN_ADDR_CORE_INTERNAL        0xE0000000UL

#define CHIP_MEMRGN_ADDR_DBGMCU               0xE0042000UL


/* Адреса блоков периферии */
#define CHIP_MEMRGN_ADDR_PERIPH_TIM2          (CHIP_MEMRGN_ADDR_APB1 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM3          (CHIP_MEMRGN_ADDR_APB1 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM4          (CHIP_MEMRGN_ADDR_APB1 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_RTC           (CHIP_MEMRGN_ADDR_APB1 + 0x2800)
#define CHIP_MEMRGN_ADDR_PERIPH_WWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_IWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI2          (CHIP_MEMRGN_ADDR_APB1 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART2        (CHIP_MEMRGN_ADDR_APB1 + 0x4400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART3        (CHIP_MEMRGN_ADDR_APB1 + 0x4800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART4        (CHIP_MEMRGN_ADDR_APB1 + 0x4C00)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C1          (CHIP_MEMRGN_ADDR_APB1 + 0x5400)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C2          (CHIP_MEMRGN_ADDR_APB1 + 0x5800)
#define CHIP_MEMRGN_ADDR_PERIPH_CAN1          (CHIP_MEMRGN_ADDR_APB1 + 0x6400)
#define CHIP_MEMRGN_ADDR_PERIPH_BKP           (CHIP_MEMRGN_ADDR_APB1 + 0x6C00)
#define CHIP_MEMRGN_ADDR_PERIPH_PWR           (CHIP_MEMRGN_ADDR_APB1 + 0x7000)
#define CHIP_MEMRGN_ADDR_PERIPH_LPTIM         (CHIP_MEMRGN_ADDR_APB1 + 0x7C00)

#define CHIP_MEMRGN_ADDR_PERIPH_AFIO          (CHIP_MEMRGN_ADDR_APB2 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTI          (CHIP_MEMRGN_ADDR_APB2 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO(n)       (CHIP_MEMRGN_ADDR_PERIPH_GPIOA + (0x400*n))
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOA         (CHIP_MEMRGN_ADDR_APB2 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOB         (CHIP_MEMRGN_ADDR_APB2 + 0x0C00)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOC         (CHIP_MEMRGN_ADDR_APB2 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOD         (CHIP_MEMRGN_ADDR_APB2 + 0x1400)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC1          (CHIP_MEMRGN_ADDR_APB2 + 0x2400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM1          (CHIP_MEMRGN_ADDR_APB2 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART1        (CHIP_MEMRGN_ADDR_APB2 + 0x3800)

#define CHIP_MEMRGN_ADDR_PERIPH_DMA1          (CHIP_MEMRGN_ADDR_AHB  + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_RCC           (CHIP_MEMRGN_ADDR_AHB  + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_FLASH         (CHIP_MEMRGN_ADDR_AHB  + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_CRC           (CHIP_MEMRGN_ADDR_AHB  + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTEN         (CHIP_MEMRGN_ADDR_AHB  + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_OPA_CMP       (CHIP_MEMRGN_ADDR_AHB  + 0x6000)
#define CHIP_MEMRGN_ADDR_PERIPH_USBPD         (CHIP_MEMRGN_ADDR_AHB  + 0x7000)
#define CHIP_MEMRGN_ADDR_PERIPH_USBFS         (0x50000000)







#endif // CHIP_MMAP_H
